"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from sifflet_sdk.client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from sifflet_sdk.client.exceptions import ApiAttributeError


def lazy_import():
    from sifflet_sdk.client.model.airflow_params import AirflowParams
    from sifflet_sdk.client.model.athena_params import AthenaParams
    from sifflet_sdk.client.model.big_query_params import BigQueryParams
    from sifflet_sdk.client.model.databricks_params import DatabricksParams
    from sifflet_sdk.client.model.dbt_cloud_params import DBTCloudParams
    from sifflet_sdk.client.model.dbt_params import DBTParams
    from sifflet_sdk.client.model.declarative_params import DeclarativeParams
    from sifflet_sdk.client.model.fivetran_params import FivetranParams
    from sifflet_sdk.client.model.hive_params import HiveParams
    from sifflet_sdk.client.model.looker_params import LookerParams
    from sifflet_sdk.client.model.microstrategy_params import MicrostrategyParams
    from sifflet_sdk.client.model.mssql_params import MssqlParams
    from sifflet_sdk.client.model.mysql_params import MysqlParams
    from sifflet_sdk.client.model.oracle_params import OracleParams
    from sifflet_sdk.client.model.postgresql_params import PostgresqlParams
    from sifflet_sdk.client.model.power_bi_params import PowerBiParams
    from sifflet_sdk.client.model.quick_sight_params import QuickSightParams
    from sifflet_sdk.client.model.redshift_params import RedshiftParams
    from sifflet_sdk.client.model.snowflake_params import SnowflakeParams
    from sifflet_sdk.client.model.synapse_params import SynapseParams
    from sifflet_sdk.client.model.tableau_params import TableauParams
    from sifflet_sdk.client.model.time_zone_dto import TimeZoneDto
    from sifflet_sdk.client.model.unknown_datasource_params import UnknownDatasourceParams
    globals()['AirflowParams'] = AirflowParams
    globals()['AthenaParams'] = AthenaParams
    globals()['BigQueryParams'] = BigQueryParams
    globals()['DBTCloudParams'] = DBTCloudParams
    globals()['DBTParams'] = DBTParams
    globals()['DatabricksParams'] = DatabricksParams
    globals()['DeclarativeParams'] = DeclarativeParams
    globals()['FivetranParams'] = FivetranParams
    globals()['HiveParams'] = HiveParams
    globals()['LookerParams'] = LookerParams
    globals()['MicrostrategyParams'] = MicrostrategyParams
    globals()['MssqlParams'] = MssqlParams
    globals()['MysqlParams'] = MysqlParams
    globals()['OracleParams'] = OracleParams
    globals()['PostgresqlParams'] = PostgresqlParams
    globals()['PowerBiParams'] = PowerBiParams
    globals()['QuickSightParams'] = QuickSightParams
    globals()['RedshiftParams'] = RedshiftParams
    globals()['SnowflakeParams'] = SnowflakeParams
    globals()['SynapseParams'] = SynapseParams
    globals()['TableauParams'] = TableauParams
    globals()['TimeZoneDto'] = TimeZoneDto
    globals()['UnknownDatasourceParams'] = UnknownDatasourceParams


class DatasourceParams(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'timezone_data': (TimeZoneDto,),  # noqa: E501
            'type': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        lazy_import()
        val = {
            'AirflowParams': AirflowParams,
            'AthenaParams': AthenaParams,
            'BigQueryParams': BigQueryParams,
            'DBTCloudParams': DBTCloudParams,
            'DBTParams': DBTParams,
            'DatabricksParams': DatabricksParams,
            'DeclarativeParams': DeclarativeParams,
            'FivetranParams': FivetranParams,
            'HiveParams': HiveParams,
            'LookerParams': LookerParams,
            'MicrostrategyParams': MicrostrategyParams,
            'MssqlParams': MssqlParams,
            'MysqlParams': MysqlParams,
            'OracleParams': OracleParams,
            'PostgresqlParams': PostgresqlParams,
            'PowerBiParams': PowerBiParams,
            'QuickSightParams': QuickSightParams,
            'RedshiftParams': RedshiftParams,
            'SnowflakeParams': SnowflakeParams,
            'SynapseParams': SynapseParams,
            'TableauParams': TableauParams,
            'UnknownDatasourceParams': UnknownDatasourceParams,
        }
        if not val:
            return None
        return {'type': val}

    attribute_map = {
        'timezone_data': 'timezoneData',  # noqa: E501
        'type': 'type',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, timezone_data, type, *args, **kwargs):  # noqa: E501
        """DatasourceParams - a model defined in OpenAPI

        Args:
            timezone_data (TimeZoneDto):
            type (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.timezone_data = timezone_data
        self.type = type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, timezone_data, type, *args, **kwargs):  # noqa: E501
        """DatasourceParams - a model defined in OpenAPI

        Args:
            timezone_data (TimeZoneDto):
            type (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.timezone_data = timezone_data
        self.type = type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
